import os
import subprocess
import random
import time
import shutil

def random_corruption_sequence():
    return [str(random.randrange(1, 200))
            for i in range(0, random.randrange(2, 15))]

bgb_path = os.path.join("helpers", "bgb.exe")
sna_path = os.path.join("helpers", "state.sna")
base_sna_path = os.path.join("helpers", "base.sna")
demo_path = os.path.join("helpers", "demo.dem")
output_screen_path = os.path.join("temp_screen.bmp")
output_sna_path = os.path.join("helpers", "temp_state.sna")

generator_path = os.path.join("helpers", "generator", "corruption_generator.exe")
generator_output = os.path.join("helpers", "generator", "sram_final.dmp")
generator_cwd = os.path.join("helpers", "generator")

sentinel = b"magicalsentinelstringthatisprettymuchguaranteedtoappearonlyonce"

cmdline = [
    bgb_path,
    "-rom", sna_path,
    "-demoplay", demo_path,
    "-screenonexit", output_screen_path,
    "-stateonexit", output_sna_path,
    "-nowarn", "-hf"
]

print("==============================================================")
print("             THEZZAZZGLITCH'S TRUECRYCOIN MINER")
print("==============================================================")
print("\"Truecrycoin\" is a distributed computing project of the")
print("Pokemon glitching community, attempting to reproduce some rare")
print("effects of certain glitch Pokemon species - the most prevalent")
print("of them all being the \"4 4's true cry\".")
print("==============================================================")
print("Partaking in the Truecrycoin project is fully voluntary.")
print("If you found this software running on your computer system")
print("without consent, close this program immediately.")
print("==============================================================")
print("A notification will be displayed if anything useful is found.")
print("You can leave this software running in the background and")
print("check periodically for updates.")
print("==============================================================")

total_counter = 0
success_counter = 0
hash_rate = 0.0

t_start = time.time()

while 1:
    corruption_sequence = random_corruption_sequence()
    print("\r%i iterations, %i successes (%.2f corruptions/min)".ljust(62)
        % (total_counter, success_counter, hash_rate), end="")

    # generate the actual SRAM corruption from sequence
    subprocess.call([generator_path] + corruption_sequence, cwd=generator_cwd)
    # copy the SRAM corruption data into savestate
    with open(base_sna_path, "rb") as f:
        sna_data = bytearray(f.read())
    with open(generator_output, "rb") as f:
        sram_data = f.read()
    sna_sram_data_at = sna_data.index(sentinel)
    if len(sram_data) != 0x2000:
        raise ValueError("invalid sram data")
    sna_data[sna_sram_data_at:sna_sram_data_at+0x2000] = sram_data
    with open(sna_path, "wb") as f:
        f.write(sna_data)
    # run the emulation
    return_code = subprocess.call(cmdline)
    if return_code != 0:
        raise RuntimeError("bgb did not exit successfully")
    # check the resulting state
    with open(output_sna_path, "rb") as f:
        sna_data = f.read()
    if sna_data.find(b"PC\x00\x02\x00\x00\x00\x38\x00") == -1:
        temp_file_name = "success_%i_%i.sna" % (total_counter, random.randrange(1, 100000))
        shutil.copyfile(output_sna_path, temp_file_name)
        print("")
        print("==============================================================")
        print("Encountering 4 4 with the currently checked data didn't yield")
        print("an rst 38 crash. Either 4 4's true cry was finally reproduced,")
        print("or you just found some other interesting effect.")
        print("In either case, it really looks like you've successfully mined")
        print("a Truecrycoin. Congratulations!")
        print("==============================================================")
        print("The SRAM corruption sequence in question:")
        print(":".join(corruption_sequence))
        print("Report this to the nearest glitch scientist in your area!")
        print("==============================================================")
        print("To aid in further research, relevant save state file has been")
        print("copied to %s." % temp_file_name)
        print("==============================================================")
        success_counter += 1
    # update counters
    total_counter += 1
    hash_rate = (total_counter * 60) / (time.time() - t_start)